mageArmorBuffs = {
	{"0000000000e14fc7", "Elemental Armor"},
	{"000000002099793b", "Stone Armor"},
	{"000000005a971341", "Dark Armor"},
	{"000000004449edd0", "Warlock Armor"},
	{"000000000470c32d", "Pyromancer's Armor"},
	{"0000000066c9d8c4", "Fire Armor"},
}

trackingBuffs = {
	{"000000007d58b532", "Track Elementals"},
	{"0000000055147613", "Track Undead"},
	{"000000000e588d4f", "Track Life Creatures"},
	{"000000000add5391", "Track Fire Creatures"},
}

function checkMageArmor ()
	local bufflist = getBuffList()
	local hasMageArmor = false
	local hasMageBuff = false

	for key,val in pairs(mageArmorBuffs) do
		abil = Inspect.Ability.Detail(val[1])
		if abil then
			hasMageArmor = true
			if bufflist[val[2]] then
				hasMageBuff = true
			end
		end
	end

	if hasMageArmor and not hasMageBuff then
		print ("Mage armor buff not found!")
	end
end

function checkTracking ()
	local bufflist = getBuffList()
	local hasTrackingAbil = false
	local hasTrackingBuff = false

	for key,val in pairs(trackingBuffs) do
		abil = Inspect.Ability.Detail(val[1])
		if abil then
			hasTrackingAbil = true
			if bufflist[val[2]] then
				hasTrackingBuff = true
			end
		end
	end

	if hasTrackingAbil and not hasTrackingBuff then
		print ("Tracking buff not found!")
	end
end




function getBuffList()
	local bufflist = Inspect.Buff.List("player")
	local buffReturn = {}
	
	if not bufflist then return end -- If we don't get anything, then we don't currently have information about the player. This may happen when the player is logging in or teleporting long distances.

	local buffdetails = Inspect.Buff.Detail("player", bufflist) -- Retrieve the details for all of our buffs. If there were only certain buffs we cared about, we could filter them out before asking for detail.

	-- We want to order buffs by their time remaining, splitting apart buffs and debuffs. We do the ordering here, in standard Lua code.
	for id, buff in pairs(buffdetails) do
		buffReturn[buff.name] = id  -- Make a copy of the ID, because we'll need it
	end
	
	return buffReturn
end
