Altometer = Altometer or {}

function getItemData()
	returnData = {}
	
	items = Inspect.Item.List()
	for key,value in pairs(items) do
		item = Inspect.Item.Detail(key)
		if item ~= nil then
			returnData[key] = item
		end
	end
	
	--[[ This is a workaround because we don't seem to get bag contents from the master list item inspector ]]--
	--[[
	for ibag=1,5,1 do
		items = Inspect.Item.List(Utility.Item.Slot.Inventory(ibag))
		for key,value in pairs(items) do
			--returnData[key] = value
		end
	end
	for bbag=1,8,1 do
		items = Inspect.Item.List(Utility.Item.Slot.Bank(bbag))
		for key,value in pairs(items) do
			--returnData[key] = value
		end
	end
	--]]
	--[[ end of workaround ]]--
	return returnData
end

function findItems(itemName)
	itemsFound = {}
	for shard,value in pairs(alt_playerInfo) do
		for player,value2 in pairs(value) do
			if value2["Items"] then
				for slot,value3 in pairs(value2["Items"]) do
					if value3.Name == itemName then
						newItem = {}
						newItem.Character = player
						newItem.Item = Item
						newItem.Name = value3.Name
						newItem.Icon = value3.Icon
						newItem.Rarity = value3.Rarity
						newItem.Stack = value3.Stack
						table.insert(itemsFound, newItem)
					end
				end	
			end
		end
	end
	return itemsFound
end

function getListOfItems()
	itemsFound = {}
	for shard,value in pairs(alt_playerInfo) do
		for player,value2 in pairs(value) do
			if value2["Items"] then
				for slot,value3 in pairs(value2["Items"]) do
					newItem = {}
					newItem.Shard = value2.Info.shard
					newItem.Character = player
					newItem.Item = Item
					newItem.Name = value3.name
					newItem.Icon = value3.icon
					newItem.Rarity = value3.rarity or "common"
					newItem.Stack = value3.stack or 1
					newItem.Slot = slot
					newItem.Type = value3.type
					newItem.Category = value3.category
					if value3.name then
						itemsFound[convertStringToValue(value3.name)] = itemsFound[convertStringToValue(value3.name)] or {}
						itemsFound[convertStringToValue(value3.name)].Items = itemsFound[convertStringToValue(value3.name)].Items or {}
						itemsFound[convertStringToValue(value3.name)].Name = value3.name
						table.insert(itemsFound[convertStringToValue(value3.name)].Items, newItem)
					end
				end	
			end
		end
	end
	return itemsFound
end

function getItemsByCategory()
	itemsByCat = {}
	for shard,value in pairs(alt_playerInfo) do
		for player,value2 in pairs(value) do
			if value2["Items"] then
				for slot,value3 in pairs(value2["Items"]) do
					newItem = {}
					newItem.Shard = value2.Info.shard
					newItem.Faction = value2.Info.faction
					newItem.Character = player
					newItem.Item = Item
					newItem.Name = value3.name
					newItem.Icon = value3.icon
					newItem.Rarity = value3.rarity or "common"
					newItem.Stack = value3.stack or 1
					newItem.Slot = slot
					newItem.Type = value3.type
					newItem.Category = value3.category
					itemsByCat[value3.category] = itemsByCat[value3.category] or {}
					itemsByCat[value3.category][value3.name] = itemsByCat[value3.category][value3.name] or {}
					table.insert(itemsByCat[value3.category][value3.name], newItem)
				end
			end
		end
	end
	return itemsByCat
end

function getItemsByParsedCategory()
	itemsByCat = {}
	for shard,value in pairs(alt_playerInfo) do
		for player,value2 in pairs(value) do
			if value2["Items"] then
				for slot,value3 in pairs(value2["Items"]) do
					cats = explode(" ", value3.category)
					itemsByCat[cats[1]] = itemsByCat[cats[1]] or {}
					itemsByCat[cats[1]][cats[2] or 1] = itemsByCat[cats[1]][cats[2] or 1] or {} 
					itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1] = itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1] or {} 
					itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1] = itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1] or {} 
					itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1][cats[5] or 1] = itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1][cats[5] or 1] or {} 
					newItem = {}
					newItem.Shard = value2.Info.shard
					newItem.Faction = value2.Info.faction
					newItem.Character = player
					newItem.Item = Item
					newItem.Name = value3.name
					newItem.Icon = value3.icon
					newItem.Rarity = value3.rarity or "common"
					newItem.Stack = value3.stack or 1
					newItem.Slot = slot
					newItem.Type = value3.type
					newItem.Category = value3.category
					itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1][cats[5] or 1][value3.name] = itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1][cats[5] or 1][value3.name] or {}
					table.insert(itemsByCat[cats[1]][cats[2] or 1][cats[3] or 1][cats[4] or 1][cats[5] or 1][value3.name], newItem)
				end
			end
		end
	end
	return itemsByCat
end

function getListOfCategories()
	catsFound = {}
	for shard,value in pairs(alt_playerInfo) do
		for player,value2 in pairs(value) do
			if value2["Items"] then
				for slot,value3 in pairs(value2["Items"]) do
					catsFound[value3.category] = value3.category
				end
			end
		end
	end
	temp = {}
	for key,value in pairs(catsFound) do
		table.insert(temp, value)
	end
	table.sort(temp)
	return temp
end

function getTooltipForItem(itemInfo)
	pMouseover = ""
	tList = {}
	for s,t in pairs(itemInfo.Items) do
		tList[t.Shard] = tList[t.Shard] or {}
		tList[t.Shard][t.Character] = tList[t.Shard][t.Character] or {}
		tList[t.Shard][t.Character][Utility.Item.Slot.Parse(t.Slot)] = tList[t.Shard][t.Character][Utility.Item.Slot.Parse(t.Slot)] or 0
		tList[t.Shard][t.Character][Utility.Item.Slot.Parse(t.Slot)] = tList[t.Shard][t.Character][Utility.Item.Slot.Parse(t.Slot)] + t.Stack
	end
	
	currChar = ""
	for shard,data in pairs (tList) do
		for player,items in pairs(data) do
			if currChar ~= "" then pMouseover = pMouseover.."\n" end
			pMouseover = pMouseover..player.." - "..shard.."\n"
			for loc,size in pairs(items) do
				pMouseover = pMouseover.."\t"..ucfirst(loc).." ("..size.."x)\n"
			end
			currChar = player.." - "..shard
		end
	end
	return pMouseover	
end

function itemSlotUpdate(updates)
	strUpdate = "Updating items -- "
	for key,value in pairs(updates) do
		strUpdate = strUpdate.."-="..key.."=- "
		Altometer.playerShard = Altometer.playerShard or Inspect.Shard().name
		Altometer.playerName = Altometer.playerName or Inspect.Unit.Detail("player").name
		if value then
			alt_playerInfo[Altometer.playerShard][Altometer.playerName].Items[key] = Inspect.Item.Detail(value)
		else
			if alt_playerInfo[Altometer.playerShard][Altometer.playerName].Items[key] then
				alt_playerInfo[Altometer.playerShard][Altometer.playerName].Items[key] = nil
			end
		end
	end
	print (strUpdate)
	--alt_playerInfo[Altometer.playerShard][Altometer.playerName]['Items'] = getItemData()
end

function getCurrentItemData(itemType)
	foundItems = {}
	for shard,data in pairs(alt_playerInfo) do
		for character,info in pairs(data) do
			for slot,item in pairs(info.Items) do
				if item.type == itemType then
					table.insert(foundItems, {["Shard"] = shard, ["Character"] = character, ["Slot"] = slot, ["Data"] = item})
				end
			end
		end
	end
	return foundItems
end

function rarityColor(rarityName)
	ret = {}
	rn = string.lower(rarityName)
	if rn == "trash" then ret.r = .34375; ret.g = .34375; ret.b = .34375;
	elseif rn == "common" then ret.r = .98; ret.g = .98 ret.b = .98;
	elseif rn == "uncommon" then ret.r = 0; ret.g = .797; ret.b = 0;
	elseif rn == "rare" then ret.r = .148; ret.g = .496; ret.b = .977;
	elseif rn == "epic" then ret.r = .676; ret.g = .281; ret.b = .98;
	elseif rn == "quest" then ret.r = 1; ret.g = 1; ret.b = 0;
	elseif rn == "relic" then ret.r = 1; ret.g = .5; ret.b = 0;
	else ret.r = .98; ret.g = .98 ret.b = .98; end
	return ret
end

function Altometer.createAuctionStyleItemWindow()
	Altometer.window.items = UI.CreateFrame("SimpleWindow", "MainWindow", Altometer.context)
	Altometer.window.items:SetCloseButtonVisible(true)
	Altometer.window.items:SetPoint("TOPLEFT", UIParent, "TOPLEFT", alt_windowSettings.posX, alt_windowSettings.posY)
	Altometer.window.items:SetTitle("ALTOMETER - ITEMS")
	Altometer.window.items:SetHeight(alt_windowSettings.height)
	Altometer.window.items:SetWidth(alt_windowSettings.width)
	Altometer.window.items:SetWidth(1000)

	function Altometer.window.items:ShowWindow()
		--[[ We are calling this here as a workaround because inventory information isn't complete when we first call for the info ]]--
		alt_playerInfo[Altometer.playerShard][Altometer.playerName]['Items'] = getItemData()
		Altometer.window.items:SetVisible(true)
	end
	
	function Altometer.window.items:ChangeCategory(view, category) 
		items = getItemsByCategory()
		temp = {}
		for key,value in pairs(items[category]) do
			table.insert(temp,key)
		end
		table.sort(temp)

		for i=1,#temp,1 do
			if not Altometer.window.items.display.list.frames[i] then
				Altometer.window.items.display.list.frames[i] = UI.CreateFrame("Frame","Item"..i,Altometer.window.items.display.list)
				Altometer.window.items.display.list.frames[i]:SetHeight(50)
				Altometer.window.items.display.list.frames[i]:SetPoint("TOPLEFT",Altometer.window.items.display.list.frames[i-1],"BOTTOMLEFT",0,50)
				Altometer.window.items.display.list.frames[i]:SetPoint("TOPRIGHT",Altometer.window.items.display.list.frames[i-1],"BOTTOMRIGHT")
				Altometer.window.items.display.list.frames[i].icon = UI.CreateFrame("Texture","itemIcon"..i,Altometer.window.items.display.list.frames[i])
				Altometer.window.items.display.list.frames[i].text = UI.CreateFrame("Text","itemText"..i,Altometer.window.items.display.list.frames[i])
				Altometer.window.items.display.list.frames[i].icon:SetPoint("TOPLEFT",Altometer.window.items.display.list.frames[i],"TOPLEFT",1,1)
				Altometer.window.items.display.list.frames[i].text:SetPoint("TOPLEFT",Altometer.window.items.display.list.frames[i].icon,"TOPRIGHT",5,12)
				Altometer.window.items.display.list.frames[i].text:SetFontSize(16)
				Altometer.window.items.display.list.frames[i].Event.MouseIn = function() Altometer.window.items:frameMouseIn(i) end
				Altometer.window.items.display.list.frames[i].Event.MouseOut = function() Altometer.window.items:frameMouseOut(i) end
			end
			Altometer.window.items.display.list.frames[i].icon:SetTexture("Rift",items[category][temp[i]][1].Icon)
			Altometer.window.items.display.list.frames[i].text:SetText(items[category][temp[i]][1].Name)
			tC = rarityColor(items[category][temp[i]][1].Rarity)
			Altometer.window.items.display.list.frames[i].text:SetFontColor(tC.r,tC.g,tC.b)
			Altometer.window.items.display.list.frames[i].data = items[category][temp[i]]
			Altometer.window.items.display.list.frames[i].Event.LeftClick = function() Altometer.window.items:itemSelect(Altometer.window.items.display.list.frames[i].data, i) end
			Altometer.window.items.display.list.frames[i]:SetVisible(true)
		end
		for i=#temp+1,#Altometer.window.items.display.list.frames,1 do
			Altometer.window.items.display.list.frames[i]:SetVisible(false)
		end

		Altometer.window.items.display.list:SetHeight(50*#temp+20)
	end

	function Altometer.window.items:frameClearSelected()
		for i=1,#Altometer.window.items.display.list.frames,1 do
			Altometer.window.items.display.list.frames[i].selected = false
			Altometer.window.items.display.list.frames[i]:SetBackgroundColor(0,0,1,0)
		end
	end
	
	function Altometer.window.items:frameMouseIn(frameItem)
		if Altometer.window.items.display.list.frames[frameItem].data then
			Altometer.window.items.display.list.frames[frameItem]:SetBackgroundColor(0,0,1,.7)
			Command.Tooltip(Altometer.window.items.display.list.frames[frameItem].data[1].Type)
		end
	end
	
	function Altometer.window.items:frameMouseOut(frameItem)
		if not Altometer.window.items.display.list.frames[frameItem].selected then 
			Altometer.window.items.display.list.frames[frameItem]:SetBackgroundColor(0,0,1,0) 
		end
	end
	
	function Altometer.window.items:categorySelect(view, item)
		Altometer.window.items:ChangeCategory(view, item)
		Altometer.window.items:frameClearSelected() 
		for tmp=1,#Altometer.window.items.details.frames,1 do
			Altometer.window.items.details.frames[tmp]:SetVisible(false)
		end
	end
	
	function Altometer.window.items:itemSelect(detailData, sourceFrame)
		-- Set selected on clicked value and remove selected from all others
		for i=1,#Altometer.window.items.display.list.frames,1 do
			if i==sourceFrame then
				Altometer.window.items.display.list.frames[i].selected = true
				Altometer.window.items.display.list.frames[i]:SetBackgroundColor(0,0,1,.7)
			else
				Altometer.window.items.display.list.frames[i].selected = false
				Altometer.window.items.display.list.frames[i]:SetBackgroundColor(0,0,1,0)
			end
		end
		
		data = getCurrentItemData(detailData[1].Type)
		
		strData = ""
		tmp = 0
		for _,value in pairs(data) do
			tmp = tmp + 1
			stack = value.Data.stack or 1
			strData = value.Character.."-"..value.Shard.." -- "..ucfirst(Utility.Item.Slot.Parse(value.Slot))
			if value.Data.stackMax then strData = strData.." ("..stack.."x)" end
			
			if tmp > #Altometer.window.items.details.frames then
				Altometer.window.items.details.frames[tmp] = UI.CreateFrame("Text","itemDetailFrame1",Altometer.window.items.details)
				Altometer.window.items.details.frames[tmp]:SetPoint("TOPLEFT",Altometer.window.items.details.frames[tmp-1],"BOTTOMLEFT")
			end
			
			Altometer.window.items.details.frames[tmp]:SetText(strData)
			Altometer.window.items.details.frames[tmp]:SetVisible(true)
		end

		for tmp=tmp+1,#Altometer.window.items.details.frames,1 do
			Altometer.window.items.details.frames[tmp]:SetVisible(false)
		end
		--[[
		data = {}
		for _,value in pairs(detailData) do
			dump(value)
			data[value.Faction] = data[value.Faction] or {}
			data[value.Faction][value.Shard] = data[value.Faction][value.Shard] or {}
			data[value.Faction][value.Shard][value.Character] = data[value.Faction][value.Shard][value.Character] or {}
			tmp = {}
			tmp.Location = value.Slot
			tmp.Count = value.Stack
			table.insert(data[value.Faction][value.Shard][value.Character],tmp)
		end
		
		for shard,value in pairs(data[Altometer.playerFaction]) do
			for character,items in pairs(value) do
				for _,item in pairs(items) do
					--dump(getCurrentItemData(item.Type))
					--print (character.." - "..shard.."     "..Utility.Item.Slot.Parse(item.Location).." ("..item.Count.."x)")
				end
			end
		end
		--dump(data)
		--]]
	end
	
	Altometer.window.items.categories = UI.CreateFrame("SimpleScrollView", "CatScroller", Altometer.window.items)
	Altometer.window.items.categories:SetPoint("BOTTOMLEFT", Altometer.window.items:GetContent(), "BOTTOMLEFT", 5, -5)
	Altometer.window.items.categories:SetWidth(200)
	Altometer.window.items.categories:SetHeight(300)
	Altometer.window.items.categories:SetBorder(1,1,1,1,1)
	Altometer.window.items.categories:SetBackgroundColor(0,0,0,.7)
	
	Altometer.window.items.categories.list = UI.CreateFrame("SimpleList", "CatList", Altometer.window.items.categories)
	Altometer.window.items.categories.list:SetItems(getListOfCategories())
	Altometer.window.items.categories.list.Event.ItemSelect = function(view, item) Altometer.window.items:categorySelect(view, item) end
	Altometer.window.items.categories:SetContent(Altometer.window.items.categories.list)
	
	Altometer.window.items.display = UI.CreateFrame("SimpleScrollView", "ItemScroller", Altometer.window.items)
	Altometer.window.items.display:SetPoint("BOTTOMLEFT", Altometer.window.items.categories, "BOTTOMRIGHT", 20, 0)
	Altometer.window.items.display:SetPoint("TOPRIGHT", Altometer.window.items:GetContent(), "TOPRIGHT", -375, 20)
	Altometer.window.items.display:SetBackgroundColor(0,0,0,.7)
	
	Altometer.window.items.display.list = UI.CreateFrame("Frame", "testframe", Altometer.window.items)
	Altometer.window.items.display.list:SetAllPoints(Altometer.window.items.display)

	Altometer.window.items.display.list.frames = {}
	Altometer.window.items.display.list.frames[1] = UI.CreateFrame("Frame","Item1",Altometer.window.items.display.list)
	Altometer.window.items.display.list.frames[1]:SetHeight(50)
	Altometer.window.items.display.list.frames[1]:SetPoint("TOPLEFT",Altometer.window.items.display.list,"TOPLEFT")
	Altometer.window.items.display.list.frames[1]:SetPoint("TOPRIGHT",Altometer.window.items.display.list,"TOPRIGHT",-20,0)
	Altometer.window.items.display.list.frames[1].icon = UI.CreateFrame("Texture","itemIcon1",Altometer.window.items.display.list.frames[1])
	Altometer.window.items.display.list.frames[1].text = UI.CreateFrame("Text","itemText1",Altometer.window.items.display.list.frames[1])
	Altometer.window.items.display.list.frames[1].icon:SetPoint("TOPLEFT",Altometer.window.items.display.list.frames[1],"TOPLEFT",1,1)
	Altometer.window.items.display.list.frames[1].text:SetPoint("TOPLEFT",Altometer.window.items.display.list.frames[1].icon,"TOPRIGHT",5,12)
	Altometer.window.items.display.list.frames[1].text:SetFontSize(16)
	Altometer.window.items.display.list.frames[1].Event.MouseIn = function() Altometer.window.items:frameMouseIn(1) end
	Altometer.window.items.display.list.frames[1].Event.MouseOut = function() Altometer.window.items:frameMouseOut(1) end
	
	Altometer.window.items.display:SetContent(Altometer.window.items.display.list)
	
	Altometer.window.items.details = UI.CreateFrame("Frame","detailFrame",Altometer.window.items)
	Altometer.window.items.details:SetPoint("TOPLEFT",Altometer.window.items.display,"TOPRIGHT",20,0)
	Altometer.window.items.details:SetPoint("BOTTOMLEFT",Altometer.window.items.display,"BOTTOMRIGHT",20,0)
	Altometer.window.items.details:SetPoint("RIGHT",Altometer.window.items:GetContent(),"RIGHT",-20,nil)
	Altometer.window.items.details:SetBackgroundColor(0,0,0,.7)

	Altometer.window.items.details.frames = {}
	Altometer.window.items.details.frames[1] = UI.CreateFrame("Text","itemDetailFrame1",Altometer.window.items.details)
	Altometer.window.items.details.frames[1]:SetPoint("TOPLEFT",Altometer.window.items.details,"TOPLEFT")
end

